image: docker/compose:latest

services:
  - docker:dind

stages:
  - tests


compliance:
  stage: tests
  when: always
  # Change cache directories to be inside the project dir so it will be cached by CI.
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
    PRE_COMMIT_HOME: ${CI_PROJECT_DIR}/.cache/pre-commit
  cache:
    paths:
      - ${PRE_COMMIT_HOME}
      - .cache/pip
      - venv/
  image: python:3.9-slim
  script:
    - apt-get update
    - apt-get install git -y   # pre-commit dependency.
    - pip install pre-commit
    - pre-commit run -v --all-files

test-users:
  stage: tests
  when: always
  before_script:
    - cd backend
    - ./setup_test_environment.sh
    - cd users
    # Copy environment variables from Gitlab into the env file.
    - mv $USERS_ENV_FILE .env
  script:
    - apk add bash  # wait-for-it script dependency.
    - .scripts/run_tests.sh

test-portfolio_results:
  stage: tests
  when: always
  before_script:
    - cd backend
    - ./setup_test_environment.sh
    - cd portfolio_results
    # Copy environment variables from Gitlab into the env file.
    - mv $PORTFOLIO_RESULTS_ENV_FILE .env
  script:
    - .scripts/run_tests.sh

test-currency_converter:
  stage: tests
  when: always
  before_script:
    - cd backend
    - ./setup_test_environment.sh
    - cd currency_converter
    # Copy environment variables from Gitlab into the env file.
    - mv $CURRENCY_CONVERTER_ENV_FILE .env
  script:
    - .scripts/run_tests.sh
